hdu 1546 Idiomatic Phrases Game【dijkstra】

Idiomatic Phrases Game

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3014    Accepted Submission(s): 973


Problem Description
Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with the two given idioms. For every two adjacent idioms, the last Chinese character of the former idiom should be the same as the first character of the latter one. For each time, Tom has a dictionary that he must pick idioms from and each idiom in the dictionary has a value indicates how long Tom will take to find the next proper idiom in the final list. Now you are asked to write a program to compute the shortest time Tom will take by giving you the idiom dictionary. 
 

Input
The input consists of several test cases. Each test case contains an idiom dictionary. The dictionary is started by an integer N (0 < N < 1000) in one line. The following is N lines. Each line contains an integer T (the time Tom will take to work out) and an idiom. One idiom consists of several Chinese characters (at least 3) and one Chinese character consists of four hex digit (i.e., 0 to 9 and A to F). Note that the first and last idioms in the dictionary are the source and target idioms in the game. The input ends up with a case that N = 0. Do not process this case. 
 

Output
One line for each case. Output an integer indicating the shortest time Tome will take. If the list can not be built, please output -1.
Sample Input
5
5 12345978ABCD2341
5 23415608ACBD3412
7 34125678AEFD4123
15 23415673ACC34123
4 41235673FBCD2156
2
20 12345678ABCD
30 DCBF5432167D
0
 


Sample Output
17
-1
 


Author
ZHOU, Ran
 

Source
 

题目大意:给你N个串,每个串都有其权值,从一个字符串的起点到终点需要其权值的消耗,问从第一个字符串的前四个字符到最后一个字符串前四个字符的最少消耗。

思路:我们可以把每一个字符串的前四个字符和后四个字符都看成一个点,然后进行最短路实现即可。N比较大,目测floyd会超时,所以选择dijkstra来实现最短路的部分。

另外大家有对于n==1的时候到底输出什么的疑惑,这里表示亲测无所谓,输出0也是AC,输出-1也是AC,所以估计后台应该是没有这组数据,所以我对于n==1的时候没有进行其他处理。

对于图的处理,我们遍历一遍即可:

        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                int len=strlen(a[i]);
                if(a[j][0] == a[i][len-4] && a[j][1] == a[i][len-3] &&a[j][2] == a[i][len-2]&&a[j][3] == a[i][len-1])w[i][j] = k[i];
                else w[i][j]=0x1f1f1f1f;
            }
        }
完整的AC代码:

#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
char a[1005][1005];
int w[1005][1005];
int vis[1005];
int d[1005];
int k[1005];
int n;
void Dij()
{
	int i,j,k,tmp;
	memset(vis,0,sizeof(vis));
	for(i=1;i<=n;i++)
	    d[i]=w[1][i];//当然是要起点开始走.
	d[1]=0;
	vis[1]=1;
	for(i=1;i<=n;i++)//为了连接多少点的控制.
	{
	    int v=-1;
		tmp=0x1f1f1f1f;
		for(j=1;j<=n;j++)
		{
			if(tmp>d[j]&&!vis[j])
			{
				tmp=d[j];
				v=j;
			}
		}//每次选中的都是距离起点最近的点.v
		if(v==-1)return ;
		vis[v]=1;
		for(k=1;k<=n;k++)
		{
			if(!vis[k])//然后松弛.
			d[k]=min(d[k],d[v]+w[v][k]);
		}
	}
}
int main()
{
    while(~scanf("%d",&n))
    {
        if(n==0)break;
        for(int i=1;i<=n;i++)
        {
            scanf("%d%s",&k[i],a[i]);
        }
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                int len=strlen(a[i]);
                if(a[j][0] == a[i][len-4] && a[j][1] == a[i][len-3] &&a[j][2] == a[i][len-2]&&a[j][3] == a[i][len-1])w[i][j] = k[i];
                else w[i][j]=0x1f1f1f1f;
            }
        }
        Dij();
        if(d[n]!=0x1f1f1f1f)
        printf("%d\n",d[n]);
        else
        printf("-1\n");
    }
}












  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值